
/**
 *	Die Mutter aller OO Beispiele
 *	@author teicher
 */
public class Auto
{
	/** Modellbezeichnung des KFZs */
	String modell;

	/** Amtliches Kennzeichen falls zugelassen, sonst null */
	String kennzeichen;

	/** Anzahl 'Pferdestaerken' */
	int ps;

	/** Klassische ("Bibliotheks")Funktion zur Umrechnung PS -> kW
	 *	@param ps Anzahl PS die umgerechnet werden sollen
	 *	@return Anzahl kW die dem Eingabewert entspricht 
	 */
	static int xgetKW(int ps)
	{
		return (int) (ps * FAKTOR_PS_ZU_KW);
	}

	/** Fhigkeit der Klasse Auto welche die PS-Zahl "dieses Autos" in kW umrechnet.
	 *	@return ps, umgerechnet in kW
	 */
	int getKW()
	{
		return (int) (ps * FAKTOR_PS_ZU_KW);
	}

	/** Haupt/Testprogramm */
	public static void main(String[] x)
	{
		Auto a = new Auto();
		Auto b = new Auto();

		a.modell = "VW Kaefer 1.1l";
		a.kennzeichen = "M-VW 22";
		a.ps = 66;
		b.modell = "BMW 316i 1.8l";
		b.ps = 122;
		b.kennzeichen = "B-MW 666";

		// Klassisch prozedural / Funktionen
		System.out.println("a:" + a.modell + "(" + a.ps + " PS / " + xgetKW(a.ps) + " kW)");
		System.out.println("b:" + b.modell + "(" + b.ps + " PS / " + xgetKW(b.ps) + " kW)");

		// objektorientiert
		System.out.println("a:" + a.modell + "(" + a.ps + " PS / " + a.getKW() + " kW)");
		System.out.println("b:" + b.modell + "(" + b.ps + " PS / " + b.getKW() + " kW)");

		System.out.println(a.getKleinanzeigenText());
		System.out.println(b.getKleinanzeigenText());
	}

	/** Umrechnunungskonstante fr PS zu kW */
	public static final float FAKTOR_PS_ZU_KW = (float)0.735499;
	// oder public static final float FAKTOR_PS_ZU_KW = 0.735499f;

	// ... hier Konstante fuer statischen Text und Tel-Nr Verkaeufer.
	// public static final ...

	/**
	 *	Erstellt Text fr die Kleinanzeige fr diese Auto.
	 *	Beispiel: "Mercedes Benz Sport Coupe 160 (118 PS). VB. Anfragen 089-123456."
	 */
	String getKleinanzeigenText()
	{
		return "...Kleinanzeigentext...";
	}
}
