
/**
 *	Die Mutter aller OO Beispiele
 *	@author teicher
 */
public class Auto
{
	public Auto() {
	}
	
	public Auto (String modell, String kennz, int ps) {
		this.modell = modell;
		this.kennzeichen = kennz;
		this.ps = ps;
	}
	
	/** Modellbezeichnung des KFZs */
	private String modell;

	/** Amtliches Kennzeichen falls zugelassen, sonst null */
	private String kennzeichen;

	/** Anzahl 'Pferdestaerken' */
	private int ps;

	/** Klassische ("Bibliotheks")Funktion zur Umrechnung PS -> kW
	 *	@param ps Anzahl PS die umgerechnet werden sollen
	 *	@return Anzahl kW die dem Eingabewert entspricht 
	 */
	static int xgetKW(int ps)
	{
		//modell = "Ford";
		return (int) (ps * FAKTOR_PS_ZU_KW);
	}

	/** Fhigkeit der Klasse Auto welche die PS-Zahl "dieses Autos" in kW umrechnet.
	 *	@return ps, umgerechnet in kW
	 */
	int getKW()
	{
		return (int) (ps * FAKTOR_PS_ZU_KW);
	}
	
	public int getPs () {
		return ps;
	}
	
	public String getModell () {
		return modell;
	}
	
	public void setModell (String neuesModell) {
		modell = neuesModell;
	}
	


	/** Umrechnunungskonstante fr PS zu kW */
	public static final float FAKTOR_PS_ZU_KW = (float)0.735499;
	// oder public static final float FAKTOR_PS_ZU_KW = 0.735499f;

	// ... hier Konstante fuer statischen Text und Tel-Nr Verkaeufer.
	// public static final ...

	/**
	 *	Erstellt Text fr die Kleinanzeige fr diese Auto.
	 *	Beispiel: "Mercedes Benz Sport Coupe 160 (118 PS). VB. Anfragen 089-123456."
	 */
	String getKleinanzeigenText()
	{
		return "...Kleinanzeigentext...";
	}
	
	
}
